<script lang="ts">
	import { entityStore } from "../../utils/entityStore";

	import CardButton from '../../ui/CardButton.svelte';

	import turnkeyInstanceTypes, { UNDERPOWERED_INSTANCE_ID } from '../../provider/TurnkeyInstanceTypes';
	import PriceLabel from '../../ui/PriceLabel.svelte';

	export let value: string;
	export let serverIsUnderpowered = false;

	let setValue = function (newValue: string): void {
		value = newValue;
		$entityStore.instanceType = newValue;
	};

	$: if (value) {
		serverIsUnderpowered = value === UNDERPOWERED_INSTANCE_ID;
	}
</script>

<div class="d-none d-md-block card etke-card-order-button header d-block w-100 text-start">
	<div class="w-100 p-2">
		<div class="d-flex">
			<div class="column-checkbox"></div>

			<div class="column-name">
				<strong>Name</strong>
			</div>

			<div class="column-cpus">
				<strong>VCPUs</strong>
			</div>

			<div class="column-ram">
				<strong>RAM</strong>
			</div>

			<div class="column-ssd">
				<strong>SSD</strong>
			</div>

			<div class="column-traffic">
				<strong>Traffic</strong>
			</div>

			<div class="column-price">
				<strong>Price</strong>
			</div>
		</div>
	</div>
</div>

{#each turnkeyInstanceTypes as instanceType}
	<div class="mb-3">
		<CardButton
			heading={instanceType.name}
			active={value == instanceType.id}
			on:activated={() => setValue(instanceType.id)}
		>
			<div slot="card-body" class="w-100 p-2">
				<div class="d-none d-md-block">
					<div class="d-flex align-items-center">
						<div class="column-checkbox text-center pt-1">
							<span
								class:text-secondary={instanceType.id != value}
								class:text-primary={instanceType.id == value}
							>
								<i
									class="fa-regular fa-lg"
									class:fa-circle={instanceType.id != value}
									class:fa-circle-dot={instanceType.id == value}
								></i>
							</span>
						</div>

						<div class="column-name">
							<div class="d-flex justify-content-between align-items-center">
								<div>
									<h4 class="fs-5">{instanceType.name}</h4>
									<div class="text-secondary">
										{instanceType.capacityDescription}
									</div>
								</div>

								{#if instanceType.recommended}
									<div>
										<span class="badge text-bg-primary me-3">
											recommended
										</span>
									</div>
								{/if}
							</div>
						</div>

						<div class="column-cpus">
							{instanceType.cpusCount}
						</div>

						<div class="column-ram">
							{instanceType.ramSizeGb}
							<span class="text-secondary">GB</span>
						</div>

						<div class="column-ssd">
							{instanceType.diskSizeGb}
							<span class="text-secondary">GB</span>
						</div>

						<div class="column-traffic">
							{instanceType.trafficTb}
							<span class="text-secondary">TB</span>
						</div>

						<div class="column-price">
							<span class="float-end"><PriceLabel price={instanceType.price}></PriceLabel></span>
						</div>
					</div>

					<div class="d-flex">
						<div class="column-checkbox"></div>

						<div class="flex-fill">


						</div>
					</div>
				</div>
				<div class="d-md-none">
					<ul class="list-group list-group-flush">
						<li class="list-group-item">
							<PriceLabel price={instanceType.price}></PriceLabel>

							<h4>{instanceType.name}</h4>

							<small class="text-secondary">{instanceType.capacityDescription}</small>
						</li>

						<li class="list-group-item d-flex justify-content-around">
							<div class="flex-fill text-start">
								<strong>VCPUs</strong>
							</div>
							<div class="flex-fill text-end">
								{instanceType.cpusCount}
							</div>
						</li>

						<li class="list-group-item d-flex justify-content-around">
							<div class="flex-fill text-start">
								<strong>RAM</strong>
							</div>
							<div class="flex-fill text-end">
								{instanceType.ramSizeGb}
								<span class="text-secondary">GB</span>
							</div>
						</li>

						<li class="list-group-item d-flex justify-content-around">
							<div class="flex-fill text-start">
								<strong>SSD</strong>
							</div>
							<div class="flex-fill text-end">
								{instanceType.diskSizeGb}
								<span class="text-secondary">GB</span>
							</div>
						</li>

						<li class="list-group-item d-flex justify-content-around">
							<div class="flex-fill text-start">
								<strong>Traffic</strong>
							</div>
							<div class="flex-fill text-end">
								{instanceType.trafficTb}
								<span class="text-secondary">TB</span>
							</div>
						</li>
					</ul>
				</div>
			</div>
		</CardButton>
		{#if serverIsUnderpowered && instanceType.id === UNDERPOWERED_INSTANCE_ID}
			<p class="alert alert-warning mt-2">
				<i class="fa-solid fa-triangle-exclamation"></i> This type of server is suitable for Matrix only, without any addons like bridges, bots, additional non-Matrix services.
			</p>
		{/if}
	</div>
{/each}

<p class="lead text-secondary">
	You can start small and upgrade to larger server sizes later.
</p>

<style>
	.header {
		border-color: transparent;
		background-color: transparent;
	}

	.column-checkbox {
		width: 4%;
	}

	.column-name {
		width: 44%;
	}

	.column-cpus, .column-ram, .column-ssd, .column-traffic, .column-price {
		width: 10.2%;
	}

	.column-price {
		text-align: right;
		font-size: 110%;
	}
</style>
